'Garden_Avenger_Robot_Servo.spin  C 2014 David Dorhout Dorhout R&D LLC
'No warrenty, all rights reserved   

CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000                                'Note Clock Speed for your setup!!

RightWheel      = 3
LeftWheel       = 2

Base            = 18 
Sholder         = 19 
Elbow           = 20 
Wrist           = 21 
WristRotation   = 22 
Gripper         = 23 

  ' Set pins and Baud rate for XBee comms  
XB_Rx     = 1     ' XBee DOUT           
XB_Tx     = 0     ' XBee DIN
XB_Baud   = 9600  ' XBee Baud Rate

CR = 13
MY_Addr  = 0        
DL_Addr  = 1        

Var

Long    RWheelPW, LWheelPW                   
Long    BasePW, SholderPW, ElbowPW, WristPW, WristRotationPW, GripperPW 
Long    Left_Dr, Right_Dr, Pan_Dr, offset, scale, RSSI, Range, speed

OBJ
  PWM     : "PWM_32_v4.spin" 
  Debug   : "FullDuplexSerialPlus"
  XB      : "XBee_Object"
  SERVO   : "Servo32v7.spin"

PUB  Start

'Inicializing  servo variables
  LWheelPW               := 1500
  RWheelPW               := 1500

  BasePW                 := 1500
  SholderPW              := 1400
  ElbowPW                := 1400
  WristPW                := 1500
  WristRotationPW        := 1500
  GripperPW              := 600


'Start Objects
  SERVO.Start                                         'Start Servo handler 
  SERVO.Ramp
  
  
  Debug.Start(31, 30, 0, 9600)
  XB.start(XB_Rx, XB_Tx, 0, XB_Baud)   ' Initialize comms for XBee

  XB.AT_Init                            ' Fast AT updates
  XB.AT_ConfigVal(string("ATMY"), MY_Addr) 
  XB.AT_Config(string("ATAP 1"))        ' Switch to API mode
                                          
   
  Debug.Str(String("Starting"))
  waitcnt(clkfreq*1 + cnt)

    speed := 750
  
    SERVO.Set(Base, BasePW)                  
    SERVO.Set(Sholder,SholderPW)
    SERVO.Set(Elbow,ElbowPW)
    SERVO.Set(Wrist,WristPW)   
    SERVO.Set(WristRotation, WristRotationPW)
    SERVO.Set(Gripper,GripperPW)

    SERVO.Set(LeftWheel, LWheelPW)
    SERVO.Set(RightWheel,RWheelPW)

MainProgram
  
Pub MainProgram
  
 Repeat
  
    Debug.Str(String(13, "going  "))
    XB.API_rx                           ' Accept data

    If XB.RxIdent == $81                ' If msg packet...
       if byte[XB.RxData] == "a"         ' If updates, pull out data
          ' get DEC data skipping 1st byte (u)
        
        BasePW   := XB.ParseDEC(XB.RxData+1,1)
        Debug.Str(String(13, "BasePW =  "))
        Debug.dec(BasePW)

        SholderPW := XB.ParseDEC(XB.RxData+1,2)
        Debug.Str(String(13, "SholderPW =  "))
        Debug.dec(SholderPW)

        ElbowPW  := XB.ParseDEC(XB.RxData+1,3) 
        Debug.Str(String(13, "ElbowPW =  "))
        Debug.dec(ElbowPW)

        WristPW  := XB.ParseDEC(XB.RxData+1,4) 
        Debug.Str(String(13, "WristPW = "))
        Debug.dec(WristPW)

        WristRotationPW  := XB.ParseDEC(XB.RxData+1,5) 
        Debug.Str(String(13, "WristRotationPW = "))
        Debug.dec(WristRotationPW)

        GripperPW  := XB.ParseDEC(XB.RxData+1,6) 
        Debug.Str(String(13, "GripperPW = "))
        Debug.dec(GripperPW)

        LWheelPW   := XB.ParseDEC(XB.RxData+1,7)
        Debug.Str(String(13, "LWheelPW =  "))
        Debug.dec(LWheelPW)
        
        'Debug.Str(String(13, "2  "))
        RWheelPW := XB.ParseDEC(XB.RxData+1,8)
        Debug.Str(String(13, "RWheelPW =  "))
        Debug.dec(RWheelPW)
        RSSI    := XB.RxRSSI
        Debug.Str(String(13, "RSSI  "))
        Debug.dec(RSSI)


  MoveServo

PUB MoveServo
  '   Repeat
    
    SERVO.Set(RightWheel,RWheelPW)
    SERVO.Set(LeftWheel,LWheelPW)

    speed := 850
    SERVO.SetRamp(Base,BasePW, speed)
    SERVO.SetRamp(Sholder,SholderPW, speed)
    SERVO.SetRamp(Elbow,ElbowPW, speed)
    Speed := 500
    SERVO.SetRamp(Wrist,WristPW, speed)
    Speed := 450 
    SERVO.SetRamp(WristRotation,WristRotationPW, speed)
    Speed := 200
    SERVO.SetRamp(Gripper,GripperPW, speed)

